## freeorion 0.4.10~rc0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

cmake_policy(SET CMP0042 NEW)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_HOME_DIRECTORY}/cmake ${CMAKE_HOME_DIRECTORY}/GG/cmake)
set(CMAKE_OSX_DEPLOYMENT_TARGET 10.9 CACHE STRING "Set the minimum OSX deployment target version")
set(CMAKE_OSX_ARCHITECTURES x86_64 CACHE STRING "Set the architecture the universal binaries for OSX should be built for")

IF(CMAKE_GENERATOR STREQUAL "Xcode")
  set(CMAKE_CONFIGURATION_TYPES Release)
ELSE()
  set(CMAKE_CONFIGURATION_TYPES Debug RelWithDebInfo Release)
ENDIF()
IF(NOT CMAKE_BUILD_TYPE)
  MESSAGE(STATUS "Setting build type to 'Release' as none was specified.")
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  SET_PROPERTY(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
ENDIF(NOT CMAKE_BUILD_TYPE)

message(STATUS "Build type CMAKE_BUILD_TYPE set to ${CMAKE_BUILD_TYPE}")

include(UseCompilerCache)
find_compiler_cache(PROGRAM ccache)


##
## Global project configuration
##

project(FreeOrion)

use_compiler_cache_with_xcode()

include(GNUInstallDirs)
include(UseCodeCoverage)
include(TargetDependencies)

set(FreeOrion_VERSION 0.4.10)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

option(BUILD_SHARED_LIBS "Build project as shared libraries." ON)
option(BUILD_TESTING "Build the testing tree." OFF)
option(BUILD_HEADLESS "Build only headless components: server and AI." OFF)

if(BUILD_TESTING)
    message( STATUS "Building Tests")
    enable_testing()
    enable_coverage()

    if(NOT TARGET unittest)
        add_custom_target(unittest
            COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure --build-config $<CONFIG>
            COMMENT "Run tests for ${CMAKE_PROJECT_NAME}"
        )
    endif()
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

if(WIN32)
    # Location of the FreeOrionSDK root
    set(CMAKE_PREFIX_PATH "${CMAKE_SOURCE_DIR}/.." CACHE PATH "Location of the FreeOrionSDK root")
    # Search dependency DLLs inside FreeOrionSDK
    target_dependencies_add_search_path("${CMAKE_PREFIX_PATH}/bin")
    set(CMAKE_INSTALL_BINDIR ".")
    set(FreeOrion_INSTALL_LIBDIR ".")
endif()

if(APPLE)
    set(FreeOrionSDK_VERSION 11)
    set(FreeOrionSDK_FILE "FreeOrionSDK_${FreeOrionSDK_VERSION}_Clang-MacOSX-10.9-x86_64.tar.bz2")
    if(NOT EXISTS "${CMAKE_BINARY_DIR}/${FreeOrionSDK_FILE}")
    file(DOWNLOAD
            "https://github.com/freeorion/freeorion-sdk/releases/download/v${FreeOrionSDK_VERSION}/${FreeOrionSDK_FILE}"
            "${CMAKE_BINARY_DIR}/${FreeOrionSDK_FILE}"
            SHOW_PROGRESS
        )
    endif()
    set(FreeOrionSDK_INSTALL_VERSION 0)
    if(EXISTS "${CMAKE_BINARY_DIR}/dep/sdkversion")
        file(READ "${CMAKE_BINARY_DIR}/dep/sdkversion" FreeOrionSDK_INSTALL_VERSION)
    endif()
    if(NOT "${FreeOrionSDK_VERSION}" EQUAL "${FreeOrionSDK_INSTALL_VERSION}")
        file(REMOVE_RECURSE "${CMAKE_BINARY_DIR}/dep")
        file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/dep")
        execute_process(COMMAND ${CMAKE_COMMAND} -E tar xfj "${CMAKE_BINARY_DIR}/${FreeOrionSDK_FILE}" WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/dep")
        file(WRITE "${CMAKE_BINARY_DIR}/dep/sdkversion" "${FreeOrionSDK_VERSION}")
    endif()
    # Location of the FreeOrionSDK root
    set(CMAKE_PREFIX_PATH "${CMAKE_BINARY_DIR}/dep/")
    set(CMAKE_FRAMEWORK_PATH "${CMAKE_BINARY_DIR}/dep/Frameworks")
    set(CMAKE_PROGRAM_PATH "${CMAKE_FRAMEWORK_PATH}/Python.framework/Versions/3.5/bin")
endif()

if(UNIX)
    set(FreeOrion_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}/freeorion")
endif()

if(APPLE)
    set(CMAKE_INSTALL_RPATH
        "@loader_path/../SharedSupport"
        "@loader_path/../Frameworks"
    )
    set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
endif()

if(NOT APPLE)
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${FreeOrion_INSTALL_LIBDIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()

if(MSVC)
    # Remove default debug flags /Zi and /MDd to allow project-specific debug flag
    STRING(REGEX REPLACE " /Zi" "" CMAKE_CXX_FLAGS_DEBUG ${CMAKE_CXX_FLAGS_DEBUG})
    STRING(REGEX REPLACE " /Zi" "" CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
    STRING(REGEX REPLACE " /MDd" "" CMAKE_CXX_FLAGS_DEBUG ${CMAKE_CXX_FLAGS_DEBUG})
endif()

add_compile_options(
    # Enable (almost) all warnings on compilers
    # https://gcc.gnu.org/onlinedocs/gcc/Warning-Options.html#index-Wall-316
    $<$<CXX_COMPILER_ID:GNU>:-Wall>
    # http://clang.llvm.org/docs/DiagnosticsReference.html#wall
    $<$<CXX_COMPILER_ID:Clang>:-Wall>
    # https://msdn.microsoft.com/en-us/library/thxezb7y.aspx#Anchor_1
    $<$<CXX_COMPILER_ID:MSVC>:/W4>

    # Disable "'<param>': unreferenced formal parameter" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4100>
    # Disable "'<class>::<member>': class '<member-type>' needs to have dll-interface to be used by clients of class '<class>'" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4251>
    # Disable "'<func>': unreferenced local function has been removed" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4505>
    # Disable "declaration of '<type>' hides global declaration" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4459>
    # Disable "function '<func>' marked as __forceinline not inlined" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4714>

    # Enable C++ Exception unwind mechanics with DLL support
    $<$<CXX_COMPILER_ID:MSVC>:/EHsc>

    # Fix Fatal Error C1128: number of sections exceeded object file format limit : compile with /bigobj on SerializeEmpire.cpp
    $<$<CXX_COMPILER_ID:MSVC>:/bigobj>

    # Produce pdb files in Debug and RelWithDebInfo configuration
    $<$<AND:$<CXX_COMPILER_ID:MSVC>,$<OR:$<CONFIG:DEBUG>,$<CONFIG:RELWITHDEBINFO>>>:/Zi>
 
    # Use the multithread-specific and DLL-specific version of the run-time library in Debug Configuration
    $<$<AND:$<CXX_COMPILER_ID:MSVC>,$<CONFIG:DEBUG>>:/MD>
)

# Determine minimum Windows target (see FreeOrion SDK)
if(WIN32)
    string(REGEX REPLACE "^v([1-9][0-9]*)(.*)$" "\\1;\\2" _VS_PLATFORM_TOOLSET "${CMAKE_VS_PLATFORM_TOOLSET}")
    message( STATUS "Toolset ${CMAKE_VS_PLATFORM_TOOLSET} regex ${_VS_PLATFORM_TOOLSET}")
    list(GET _VS_PLATFORM_TOOLSET 1 _VS_PLATFORM_TOOLSET_TARGET)
    message( STATUS "Target ${_VS_PLATFORM_TOOLSET_TARGET}")
endif()

set_property(DIRECTORY APPEND
    PROPERTY COMPILE_DEFINITIONS
        # Set minimum Windows target version to WindowsXP or Vista depending on toolset
        # https://msdn.microsoft.com/en-us/library/aa383745.aspx
        # Use numeric to correctly compare it in <boost\log\detail\config.hpp>
        $<$<PLATFORM_ID:Windows>:_WIN32_WINNT=$<IF:$<STREQUAL:${_VS_PLATFORM_TOOLSET_TARGET},_xp>,0x0501,0x0600>>
        # Default to unicode variants when using Win32 API
        # https://msdn.microsoft.com/en-us/library/dybsewaf.aspx
        $<$<PLATFORM_ID:Windows>:_UNICODE>
        # Disable "'<func>' was declared deprecated" warning
        # https://msdn.microsoft.com/en-us/library/ttcz0bys.aspx
        $<$<PLATFORM_ID:Windows>:_CRT_SECURE_NO_WARNINGS>
        # Disable '<func>': Function call with parameters that may be unsafe" warning
        # https://msdn.microsoft.com/en-us/library/ttcz0bys.aspx
        $<$<PLATFORM_ID:Windows>:_SCL_SECURE_NO_WARNINGS>
        # Disable '<func>': The POSIX name for this item is deprecated." warning
        # https://msdn.microsoft.com/en-us/library/ttcz0bys.aspx
        $<$<PLATFORM_ID:Windows>:_CRT_NONSTDC_NO_WARNINGS>

        # Suppress "Boost.Config is older than your compiler version" warning
        $<$<PLATFORM_ID:Windows>:BOOST_CONFIG_SUPPRESS_OUTDATED_MESSAGE>

        # Define platform specific macros
        $<$<PLATFORM_ID:Windows>:FREEORION_WIN32>
        $<$<PLATFORM_ID:Darwin>:FREEORION_MACOSX>
        $<$<PLATFORM_ID:Linux>:FREEORION_LINUX>
        $<$<PLATFORM_ID:FreeBSD>:FREEORION_FREEBSD>
        $<$<PLATFORM_ID:OpenBSD>:FREEORION_OPENBSD>
)

if(WIN32 AND MSVC AND NOT (MSVC_VERSION LESS 1900)) # _MSC_VER >= 1900
    # fix https://bugs.python.org/issue36020
    # ToDo: remove after fix will be applied in python-cmake
    # ToDo: use GREATER_EQUAL after updating to cmake >= 3.7
    set_property(DIRECTORY APPEND
        PROPERTY COMPILE_DEFINITIONS
        HAVE_SNPRINTF
    )
endif()

if(WIN32 AND MSVC)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
endif()

if(UNIX AND NOT APPLE)
    add_definitions(-DENABLE_BINRELOC -DBINPATH=\"${CMAKE_INSTALL_FULL_BINDIR}\" -DSHAREPATH=\"${CMAKE_INSTALL_FULL_DATADIR}\")
endif()

include(TestForBug2795)


##
## Collect project dependencies.
##

set(MINIMUM_PYTHON_VERSION 3.5)
set(MINIMUM_BOOST_VERSION 1.58.0)

find_package(Threads)
find_package(PythonInterp ${MINIMUM_PYTHON_VERSION} REQUIRED)
find_package(PythonLibs ${MINIMUM_PYTHON_VERSION} REQUIRED)
find_package(Boost ${MINIMUM_BOOST_VERSION}
    COMPONENTS
        filesystem
        iostreams
        locale
        log
        log_setup
        serialization
        system
        thread
    REQUIRED)

find_package(Boost COMPONENTS python${PYTHON_VERSION_MAJOR}${PYTHON_VERSION_MINOR} REQUIRED)
set(Boost_PYTHON_SUFFIX "${PYTHON_VERSION_MAJOR}${PYTHON_VERSION_MINOR}")

find_package(ZLIB REQUIRED)
if(NOT BUILD_HEADLESS)
    set(SDL_NO_MAIN true)
    find_package(SDL REQUIRED)
    find_package(Freetype REQUIRED)
    find_package(OpenGL REQUIRED)
    find_package(OpenAL REQUIRED)
    find_package(Ogg REQUIRED)
    find_package(Vorbis REQUIRED)
endif()

if(APPLE)
    find_library(CORE_FOUNDATION_LIBRARY CoreFoundation)
    find_library(ICONV_LIBRARY iconv)
endif()

if(BUILD_TESTING)
    add_subdirectory(test)
endif()

set(BUILD_DEVEL_PACKAGE OFF CACHE INTERNAL "Disables installation of GiGi development files." FORCE)
set(_ORIG_CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
set(CMAKE_INSTALL_LIBDIR "${FreeOrion_INSTALL_LIBDIR}")
add_subdirectory(GG)
set(CMAKE_INSTALL_LIBDIR ${_ORIG_CMAKE_INSTALL_LIBDIR})
unset(_ORIG_CMAKE_INSTALL_LIBDIR)

set_property(DIRECTORY APPEND
    PROPERTY COMPILE_DEFINITIONS
        # Boost iostreams doesn't honor BOOST_ALL_NO_LIB when linking zlib.
        # It also tries to link by default to the boost in-source zlib librar,
        # which we don't want.
        # http://www.boost.org/doc/libs/1_59_0/boost/iostreams/detail/config/zlib.hpp
        $<$<PLATFORM_ID:Windows>:BOOST_ZLIB_BINARY=zlib.lib>

        # with boost 1.61 some boost::optional internals were changed. However
        # boost::spirit relies on some API the old implementation provided.
        # This define enables the usage of the old boost::optional
        # implementation.  Boost upstream tracks this bug as #12349
        $<$<AND:$<VERSION_GREATER:${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION},1.60>,$<VERSION_LESS:${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION},1.67>>:BOOST_OPTIONAL_CONFIG_USE_OLD_IMPLEMENTATION_OF_OPTIONAL>

        # We don't need localized output of Boost date_time and not setting
        # the define causes the inclusion of code, which contains std::tolower.
        # This however causes a macro substitutions caused by the libpython
        # headers, which in turn breaks the build.  Python 2.7.13 should have
        # fixed this with python bug #10910
        $<$<PLATFORM_ID:Darwin>:BOOST_DATE_TIME_NO_LOCALE>
        $<$<PLATFORM_ID:FreeBSD>:BOOST_DATE_TIME_NO_LOCALE>
)


##
## Define main project targets.
##

# To run the version generation every compile we need to deferr the
# execution to a separate target and the existing python command
add_custom_target(freeorionversion
    COMMAND
    "${PYTHON_EXECUTABLE}"
    "${CMAKE_SOURCE_DIR}/cmake/make_versioncpp.py"

=== GG/CMakeLists.txt ===
# GG is a GUI for OpenGL.
#
# Copyright (C) 2009-2011 T. Zach Laine
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA
#
# If you do not wish to comply with the terms of the LGPL please
# contact the author as other terms are available for a fee.
#
# Zach Laine
# whatwasthataddress@gmail.com

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_HOME_DIRECTORY}/cmake)


##
## Global project configuration
##

project(GiGi)

include(CMakeDependentOption)
include(GNUInstallDirs)
include(UseCodeCoverage)
include(Util)

set(GIGI_VERSION 0.8.0)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(ENABLE_PNG_TEXTURES "Enable PNG texture support." ON)
option(ENABLE_TIFF_TEXTURES "Enable TIFF texture support." OFF)
option(BUILD_DOCUMENTATION "Builds HTML documentation." OFF)
option(BUILD_TESTING "Build the testing tree." OFF)
option(BUILD_DEVEL_PACKAGE "Install development files." ON)
option(BUILD_HEADLESS "Headless components: server and AI." OFF)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})


if(MSVC)
    set(CMAKE_STATIC_LIBRARY_PREFIX "lib")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
    set(CMAKE_STATIC_LINKER_FLAGS "${CMAKE_STATIC_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")

    add_definitions(/wd4146 /wd4099 /wd4251 /wd4800 /wd4267 /wd4275
                    /wd4244 /wd4101 /wd4258 /wd4351 /wd4996)
    add_definitions(
        /EHsc
        -D_UNICODE
    )
endif()


##
## Collect project dependencies.
##

set(MINIMUM_BOOST_VERSION 1.58.0)

find_package(Boost ${MINIMUM_BOOST_VERSION} COMPONENTS filesystem regex system REQUIRED)

if(NOT BUILD_HEADLESS)
    find_package(OpenGL REQUIRED)
    find_package(GLEW REQUIRED)
    find_package(Freetype REQUIRED)

    if(ENABLE_PNG_TEXTURES)
        find_package(PNG REQUIRED)
        set(int_have_png 1)
    else()
        set(int_have_png 0)
    endif()
    
    if(ENABLE_TIFF_TEXTURES)
        find_package(TIFF REQUIRED)
        set(int_have_tiff 1)
    else()
        set(int_have_tiff 0)
    endif()
endif()

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/GG/Config.h
    @ONLY
)


##
## Define main project targets.
##

add_library(GiGi "")

add_library(GiGi::GiGi ALIAS GiGi)

target_compile_definitions(GiGi
    PRIVATE
        -DFONS_USE_FREETYPE
        # Starting with boost 1.68 boost::gil integrates support for
        # grayscale-alpha png images, so prefer their implementation
        # instead of our hacky gilext code.
        $<$<VERSION_LESS:${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION},1.68>:GIGI_CONFIG_USE_OLD_IMPLEMENTATION_OF_GIL_PNG_IO>
        $<$<VERSION_GREATER:${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION},1.67>:BOOST_GIL_IO_ENABLE_GRAY_ALPHA>
        $<$<VERSION_GREATER:${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION},1.71>:BOOST_GIL_USES_MP11>
)

target_include_directories(GiGi
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
)

set_target_properties(GiGi PROPERTIES LINKER_LANGUAGE CXX)

if(NOT BUILD_HEADLESS)
    target_include_directories(GiGi
        INTERFACE
            ${OPENGL_INCLUDE_DIR}
        PRIVATE
            ${FREETYPE_INCLUDE_DIRS}
    )

    target_link_libraries(GiGi
        PUBLIC
            GLEW::GLEW
            Boost::boost
            Boost::disable_autolinking
            Boost::dynamic_linking
            Boost::filesystem
            ${OPENGL_gl_LIBRARY}
        PRIVATE
            Boost::regex
            ${FREETYPE_LIBRARIES}
    )

    if(TARGET PNG::PNG)
        target_link_libraries(GiGi PRIVATE PNG::PNG)
    endif()

    if(TARGET TIFF::TIFF)
        target_link_libraries(GiGi PRIVATE TIFF::TIFF)
    endif()


    ##
    ## Recurse into sources.
    ##

    add_subdirectory(GG)
    add_subdirectory(src)

    if(BUILD_TESTING)
        enable_testing()
        enable_coverage()

        if(NOT TARGET unittest)
            add_custom_target(unittest
                COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
                COMMENT "Run tests for ${CMAKE_PROJECT_NAME}"
            )
        endif()

        add_subdirectory(test)
    endif()
endif()

if(BUILD_DOCUMENTATION)
    add_subdirectory(doc)
endif()


##
## Install targets and package project.
##

if(BUILD_DEVEL_PACKAGE)
    install(
        DIRECTORY GG
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        COMPONENT COMPONENT_GIGI_DEVEL
    )
endif()

if(UNIX AND NOT APPLE AND NOT BUILD_HEADLESS)
    install(
        TARGETS GiGi
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT COMPONENT_GIGI
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT COMPONENT_GIGI
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT COMPONENT_GIGI_DEVEL
    )
endif()

if(UNIX AND BUILD_DEVEL_PACKAGE AND NOT BUILD_HEADLESS)
    get_pkg_config_libs(pkg_config_libs ${GiGi_LINK_LIBS})

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/cmake/GiGi.pc.in
        ${CMAKE_BINARY_DIR}/GiGi.pc
        @ONLY
    )

    install(
        FILES ${CMAKE_BINARY_DIR}/GiGi.pc
        DESTINATION  ${CMAKE_INSTALL_LIBDIR}/pkgconfig
        COMPONENT COMPONENT_GIGI_DEVEL
        OPTIONAL
    )
endif()


set(CPACK_PACKAGE_VERSION ${GIGI_VERSION})
set(CPACK_PACKAGE_VENDOR "T. Zachary Laine")
set(CPACK_PACKAGE_CONTACT ${CPACK_PACKAGE_VENDOR})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A C++ OpenGL GUI library.")
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/COPYING)
set(CPACK_SYSTEM_NAME ${CMAKE_SYSTEM_NAME})
set(CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-${CPACK_SYSTEM_NAME}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-src)

# RPM-specific settings
set(CPACK_RPM_PACKAGE_LICENSE LGPL)
set(CPACK_RPM_PACKAGE_REQUIRES)

list(APPEND CPACK_RPM_PACKAGE_REQUIRES Mesa freetype2)
list(APPEND CPACK_RPM_PACKAGE_REQUIRES gigi=${GIGI_VERSION})

if(BUILD_DEVEL_PACKAGE)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES boost-devel>=1.44.0 Mesa-devel freetype2-devel)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES gigi-devel=${GIGI_VERSION})
endif()

# Deb-specific settings
set(CPACK_DEBIAN_PACKAGE_SECTION libs)

set(CPACK_DEBIAN_PACKAGE_DEPENDS "libgl1-mesa-glx | libgl1, libfreetype6")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, gigi (= ${GIGI_VERSION})")

if(BUILD_DEVEL_PACKAGE)
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "boost-devel (>= 1.44.0), libgl1-mesa-dev | libgl-dev, libfreetype6-dev")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, gigi-dev (= ${GIGI_VERSION})")
endif()

if(UNIX)
    set(CPACK_GENERATOR "TGZ;TBZ2")
    find_program(RPMBUILD rpmbuild)
    if(RPMBUILD)
        list(APPEND CPACK_GENERATOR RPM)
    endif()
    set(RPMBUILD ${RPMBUILD} CACHE INTERNAL "")
    find_program(DPKG dpkg)
    if(DPKG)
        list(APPEND CPACK_GENERATOR DEB)
    endif()
    set(DPKG ${DPKG} CACHE INTERNAL "")
    set(CPACK_SOURCE_GENERATOR "TGZ;TBZ2")
elseif(WIN32)
    set(CPACK_GENERATOR "NSIS")
    set(CPACK_SOURCE_GENERATOR "ZIP")
endif()

include(CPack)

cpack_add_component(
    COMPONENT_GIGI
    DISPLAY_NAME GiGi
    DESCRIPTION "The core GG library, including the GUI state machine and all the controls.  Not usable without an input driver."
    REQUIRED
    GROUP COMPONENT_GROUP_RUNTIME
)

cpack_add_component(
    COMPONENT_GIGI_DEVEL
    DISPLAY_NAME "GiGi"
    DESCRIPTION "The files necessary to do development with GiGi."
    GROUP COMPONENT_GROUP_DEVEL
    DEPENDS COMPONENT_GIGI
)

cpack_add_component_group(
    COMPONENT_GROUP_RUNTIME
    DISPLAY_NAME "Runtime"
    DESCRIPTION "The runtime libs needed to run an application that uses GG."
    EXPANDED
)

cpack_add_component_group(
    COMPONENT_GROUP_DEVEL
    DISPLAY_NAME "Development"
    DESCRIPTION "The development libs and headers needed to build an application that uses GG."
    EXPANDED
)

=== test/UI/CMakeLists.txt ===
macro(ADD_FO_ACCEPTANCE_TEST name)
    add_executable(fo_acceptance_${name}
        ${ARGN}
    )
    target_link_libraries(fo_acceptance_${name}
        fo_acceptance_runner
    )
endmacro()

find_package(GLEW REQUIRED)

include_directories(
    SYSTEM
    ${OPENGL_INCLUDE_DIR}
)

add_library(fo_acceptance_runner STATIC
    runner/Application.cpp
    runner/Dialog.cpp
    runner/ResourceCursor.cpp
    ../../UI/SDLGUI.cpp
)

target_link_libraries(fo_acceptance_runner
    PUBLIC
        GiGi
        GLEW::GLEW
        ${SDL_LIBRARIES}
)

target_include_directories(fo_acceptance_runner
    PUBLIC
        ${SDL_INCLUDE_DIR}
)

add_fo_acceptance_test(text_control TestTextControl.cpp)

=== GG/test/unit/CMakeLists.txt ===
# GG is a GUI for OpenGL.
#
# Copyright (C) 2010 T. Zachary Laine
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA
#
# If you do not wish to comply with the terms of the LGPL please
# contact the author as other terms are available for a fee.
#
# Zach Laine
# whatwasthataddress@gmail.com

find_package(Boost ${MINIMUM_BOOST_VERSION} COMPONENTS unit_test_framework REQUIRED)

add_executable(gg_unittest
    main.cpp
)

target_link_libraries(gg_unittest
    GiGi
    Boost::boost
    Boost::disable_autolinking
    Boost::dynamic_linking
    Boost::unit_test_framework
)

add_coverage(fo_unittest_parse
    unittest
)

add_dependencies(unittest
    gg_unittest
)

set(GiGi_TESTS
    TestButton
)

foreach(_TEST ${GiGi_TESTS})
    target_sources(gg_unittest
        PRIVATE
        ${_TEST}.cpp
    )
    add_test(
        NAME ${_TEST}
        COMMAND gg_unittest --log_level=message "--run_test=${_TEST}" --catch_system_error=yes
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
endforeach()

=== debian/changelog ===
freeorion (0.4.10~rc0-0ubuntu3) groovy; urgency=medium

  * No-change rebuild against libboost-regex1.71.0-icu67

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 28 Jul 2020 19:19:33 +0000

freeorion (0.4.10~rc0-0ubuntu2) groovy; urgency=medium

  * No change rebuild against new icu ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 27 Jul 2020 16:41:21 +0100

freeorion (0.4.10~rc0-0ubuntu1) groovy; urgency=medium

  * New upstream release. Snapshot of v0.4.10 branch.
  * Switch to python3 & boost1.71

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 01 Jun 2020 11:41:41 +0100

freeorion (0.4.9-1ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - use python2 & boost1.67

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 01 Jun 2020 11:23:50 +0100

freeorion (0.4.8-3ubuntu5) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 08:51:32 +0100

freeorion (0.4.8-3ubuntu4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:21:00 +0100

freeorion (0.4.8-3ubuntu3) focal; urgency=medium

  * Use boost1.67 for boost-python2.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 17 Feb 2020 20:03:52 +0000

freeorion (0.4.8-3ubuntu2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 10 Feb 2020 08:22:52 +0100

freeorion (0.4.8-3ubuntu1) focal; urgency=medium

  * Build-depend on python2.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Jan 2020 15:38:58 +0100

freeorion (0.4.8-3build1) focal; urgency=medium

  * No-change rebuild to generate dependencies on python2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Dec 2019 12:33:22 +0000

=== debian/control ===
Source: freeorion
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 dh-python,
 libalut-dev,
 libboost-all-dev,
 libfreetype6-dev,
 libgl1-mesa-dev,
 libglew-dev,
 libglu1-mesa-dev,
 libjpeg-dev,
 libogg-dev,
 libopenal-dev,
 libpng-dev,
 libsdl2-dev,
 libtiff-dev,
 libvorbis-dev,
 pkg-config,
 python3
Standards-Version: 4.5.0
Homepage: http://www.freeorion.org
Vcs-Git: https://salsa.debian.org/games-team/freeorion.git
Vcs-Browser: https://salsa.debian.org/games-team/freeorion

Package: freeorion
Architecture: linux-any
Depends:
 freeorion-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: turn-based space empire and galactic conquest game
 FreeOrion is a turn-based space empire and galactic conquest (4X) game being
 designed and built by the FreeOrion project. FreeOrion is inspired by the
 tradition of the Master of Orion games, but is not a clone or remake of that
 series or any other game.
 .
 The game is about the construction of a living, breathing universe in a grand
 campaign model. You can develop your own galactic empire and explore new star
 systems with your fleets as one of several unique human or alien species.
 Colonization of new worlds, researching new technology, managing your
 resources and defending your planets against the AI or other human players on
 a galactic scale are your main objectives.

Package: freeorion-data
Architecture: all
Depends:
 fonts-dejavu,
 fonts-roboto-unhinted,
 ${misc:Depends},
 ${python3:Depends}
Suggests:
 freeorion
Description: turn-based space empire and galactic conquest game -- data
 FreeOrion is a turn-based space empire and galactic conquest (4X) game being
 designed and built by the FreeOrion project.
 .
 This package provides architecture-independent data files for FreeOrion,
 hundreds of unique designs for in-game icons, ships and planets, many
 different sounds and an immersive music score.
 .
 Also included are in-game descriptions, translations and game scripts.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export CCACHE_DIR=$(CURDIR)/ccache
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

MAX  := 2
TYPE := RelWithDebInfo

ifeq (32,$(DEB_HOST_ARCH_BITS))
ifeq (,$(filter $(DEB_HOST_ARCH), i386))
	MAX  := 1
	TYPE := Release
	export DEB_CFLAGS_MAINT_APPEND = -g1
	export DEB_CXXFLAGS_MAINT_APPEND = -g1
endif
endif

%:
	dh $@ --max-parallel=$(MAX) --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_DOCUMENTATION=off \
		-DBUILD_TUTORIALS=off \
		-DLIB_SUFFIX=/freeorion \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DCMAKE_BUILD_TYPE=$(TYPE)

#workaround for 'dpkg-shlibdeps: error: couldn't find library libGiGi*.so'
override_dh_shlibdeps:
	LD_LIBRARY_PATH="$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/freeorion:$(LD_LIBRARY_PATH)" dh_shlibdeps

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog.md

override_dh_missing:
	dh_missing --fail-missing

override_dh_install:
	dh_install
	find debian -type d -empty -delete -printf 'removed %p\n'
	$(RM) -v debian/freeorion-data/usr/share/games/freeorion/default/LICENSE* \
		debian/freeorion-data/usr/share/games/freeorion/default/COPYING \
		debian/freeorion-data/usr/share/games/freeorion/default/data/fonts/LICENSE.*

override_dh_python3:
	dh_python3 -pfreeorion-data /usr/share/games

get-orig-source:
	wget https://codeload.github.com/freeorion/freeorion/tar.gz/4428a2ce7bb7cb42f3eae8f7ab0d99a9eed9247f

## freeorion 0.4.10

=== debian/changelog ===
freeorion (0.4.10-1~mx17+1) mx; urgency=medium

  * Rebuild for MX-17/18.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Fri, 02 Oct 2020 20:58:52 -0700

freeorion (0.4.10-1~mx19+1) mx; urgency=medium

  * Rebuild for MX-19.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Fri, 02 Oct 2020 20:00:35 -0700

freeorion (0.4.10-1) unstable; urgency=medium

  * New upstream version 0.4.10.

 -- Markus Koschany <apo@debian.org>  Fri, 31 Jul 2020 13:33:50 +0200

freeorion (0.4.10~RC1-1) unstable; urgency=medium

  * New upstream version 0.4.10~RC1.
    - Support Python 3 now. (Closes: #936557)
  * Switch to debhelper-compat = 13.

 -- Markus Koschany <apo@debian.org>  Wed, 22 Jul 2020 22:46:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,29 +1,27 @@
 Source: freeorion
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
 XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders:
- Markus Koschany <apo@debian.org>
-Build-Depends:
- cmake,
- debhelper-compat (= 12),
- dh-python,
- libalut-dev,
- libboost-all-dev,
- libfreetype6-dev,
- libgl1-mesa-dev,
- libglew-dev,
- libglu1-mesa-dev,
- libjpeg-dev,
- libogg-dev,
- libopenal-dev,
- libpng-dev,
- libsdl2-dev,
- libtiff-dev,
- libvorbis-dev,
- pkg-config,
- python3
+Uploaders: Markus Koschany <apo@debian.org>
+Build-Depends: cmake,
+               debhelper-compat (= 12),
+               dh-python,
+               libalut-dev,
+               libboost-all-dev,
+               libfreetype6-dev,
+               libgl1-mesa-dev,
+               libglew-dev,
+               libglu1-mesa-dev,
+               libjpeg-dev,
+               libogg-dev,
+               libopenal-dev,
+               libpng-dev,
+               libsdl2-dev,
+               libtiff-dev,
+               libvorbis-dev,
+               pkg-config,
+               python3
 Standards-Version: 4.5.0
 Homepage: http://www.freeorion.org
 Vcs-Git: https://salsa.debian.org/games-team/freeorion.git
@@ -31,10 +29,9 @@
 
 Package: freeorion
 Architecture: linux-any
-Depends:
- freeorion-data (= ${source:Version}),
- ${misc:Depends},
- ${shlibs:Depends}
+Depends: freeorion-data (= ${source:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: turn-based space empire and galactic conquest game
  FreeOrion is a turn-based space empire and galactic conquest (4X) game being
  designed and built by the FreeOrion project. FreeOrion is inspired by the
@@ -50,13 +47,11 @@
 
 Package: freeorion-data
 Architecture: all
-Depends:
- fonts-dejavu,
- fonts-roboto-unhinted,
- ${misc:Depends},
- ${python3:Depends}
-Suggests:
- freeorion
+Depends: fonts-dejavu,
+         fonts-roboto-unhinted,
+         ${misc:Depends},
+         ${python3:Depends}
+Suggests: freeorion
 Description: turn-based space empire and galactic conquest game -- data
  FreeOrion is a turn-based space empire and galactic conquest (4X) game being
  designed and built by the FreeOrion project.

## freeorion 0.4.10.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -36,7 +36,7 @@
 include(UseCodeCoverage)
 include(TargetDependencies)
 
-set(FreeOrion_VERSION 0.4.10)
+set(FreeOrion_VERSION 0.4.10.1)
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)

=== UI/CMakeLists.txt ===
add_subdirectory(CombatReport)

target_sources(freeorion
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/About.h
        ${CMAKE_CURRENT_LIST_DIR}/AccordionPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/BuildDesignatorWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/BuildingsPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/CensusBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ChatWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ClientUI.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatLogWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatReportData.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatReportWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/GraphicalSummary.h
        ${CMAKE_CURRENT_LIST_DIR}/CUIControls.h
        ${CMAKE_CURRENT_LIST_DIR}/CUIDrawUtil.h
        ${CMAKE_CURRENT_LIST_DIR}/CUILinkTextBlock.h
        ${CMAKE_CURRENT_LIST_DIR}/CUISlider.h
        ${CMAKE_CURRENT_LIST_DIR}/CUISpin.h
        ${CMAKE_CURRENT_LIST_DIR}/CUIStyle.h
        ${CMAKE_CURRENT_LIST_DIR}/CUIWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/DesignWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/EncyclopediaDetailPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/FieldIcon.h
        ${CMAKE_CURRENT_LIST_DIR}/FleetButton.h
        ${CMAKE_CURRENT_LIST_DIR}/FleetWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/GalaxySetupWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/GraphControl.h
        ${CMAKE_CURRENT_LIST_DIR}/Hotkeys.h
        ${CMAKE_CURRENT_LIST_DIR}/IconTextBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/InGameMenu.h
        ${CMAKE_CURRENT_LIST_DIR}/IntroScreen.h
        ${CMAKE_CURRENT_LIST_DIR}/LinkText.h
        ${CMAKE_CURRENT_LIST_DIR}/MapWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/MeterBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/MilitaryPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/ModeratorActionsWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiIconValueIndicator.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiMeterStatusBar.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiplayerLobbyWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ObjectListWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/OptionsWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/PasswordEnterWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/PlayerListWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/PopulationPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/ProductionWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/QueueListBox.h
        ${CMAKE_CURRENT_LIST_DIR}/ResearchWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ResourceBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ResourcePanel.h
        ${CMAKE_CURRENT_LIST_DIR}/SaveFileDialog.h
        ${CMAKE_CURRENT_LIST_DIR}/SDLGUI.h
        ${CMAKE_CURRENT_LIST_DIR}/ServerConnectWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ShaderProgram.h
        ${CMAKE_CURRENT_LIST_DIR}/SidePanel.h
        ${CMAKE_CURRENT_LIST_DIR}/SitRepPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/Sound.h
        ${CMAKE_CURRENT_LIST_DIR}/SpecialsPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/SystemIcon.h
        ${CMAKE_CURRENT_LIST_DIR}/SystemResourceSummaryBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeArcs.h
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeLayout.h
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/TextBrowseWnd.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/About.cpp
        ${CMAKE_CURRENT_LIST_DIR}/AccordionPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/BuildDesignatorWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/BuildingsPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CensusBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ChatWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ClientUI.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatLogWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatReportData.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatReportWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/GraphicalSummary.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUIControls.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUIDrawUtil.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUILinkTextBlock.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUIStyle.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUIWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/DesignWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EncyclopediaDetailPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FieldIcon.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FleetButton.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FleetWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/GalaxySetupWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/GraphControl.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Hotkeys.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IconTextBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/InGameMenu.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IntroScreen.cpp
        ${CMAKE_CURRENT_LIST_DIR}/LinkText.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MapWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MeterBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MilitaryPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ModeratorActionsWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MultiIconValueIndicator.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MultiMeterStatusBar.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MultiplayerLobbyWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ObjectListWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/OptionsWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PasswordEnterWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PlayerListWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PopulationPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ProductionWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/QueueListBox.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResearchWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResourceBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResourcePanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SaveFileDialog.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SDLGUI.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ServerConnectWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShaderProgram.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SidePanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SitRepPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Sound.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SpecialsPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SystemIcon.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SystemResourceSummaryBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeArcs.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeLayout.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TextBrowseWnd.cpp
)

=== test/CMakeLists.txt ===
add_subdirectory(parse)
add_subdirectory(util)
add_subdirectory(system)

if (NOT BUILD_HEADLESS)
    add_subdirectory(UI)
endif ()

=== GG/GG/CMakeLists.txt ===
# GG is a GUI for OpenGL.
#
# Copyright (C) 2017 Marcel Metz
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA
#
# If you do not wish to comply with the terms of the LGPL please
# contact the author as other terms are available for a fee.
#
# Zach Laine
# whatwasthataddress@gmail.com

add_subdirectory(dialogs)
add_subdirectory(RichText)

target_sources(GiGi
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/AlignmentFlags.h
        ${CMAKE_CURRENT_LIST_DIR}/Base.h
        ${CMAKE_CURRENT_LIST_DIR}/BrowseInfoWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/Button.h
        ${CMAKE_CURRENT_LIST_DIR}/ClrConstants.h
        ${CMAKE_CURRENT_LIST_DIR}/Clr.h
        ${CMAKE_CURRENT_LIST_DIR}/Config.h
        ${CMAKE_CURRENT_LIST_DIR}/Control.h
        ${CMAKE_CURRENT_LIST_DIR}/Cursor.h
        ${CMAKE_CURRENT_LIST_DIR}/DeferredLayout.h
        ${CMAKE_CURRENT_LIST_DIR}/DrawUtil.h
        ${CMAKE_CURRENT_LIST_DIR}/DropDownList.h
        ${CMAKE_CURRENT_LIST_DIR}/DynamicGraphic.h
        ${CMAKE_CURRENT_LIST_DIR}/Edit.h
        ${CMAKE_CURRENT_LIST_DIR}/Enum.h
        ${CMAKE_CURRENT_LIST_DIR}/Exception.h
        ${CMAKE_CURRENT_LIST_DIR}/Export.h
        ${CMAKE_CURRENT_LIST_DIR}/Flags.h
        ${CMAKE_CURRENT_LIST_DIR}/FontFwd.h
        ${CMAKE_CURRENT_LIST_DIR}/Font.h
        ${CMAKE_CURRENT_LIST_DIR}/GGFwd.h
        ${CMAKE_CURRENT_LIST_DIR}/GLClientAndServerBuffer.h
        ${CMAKE_CURRENT_LIST_DIR}/GroupBox.h
        ${CMAKE_CURRENT_LIST_DIR}/GUI.h
        ${CMAKE_CURRENT_LIST_DIR}/Layout.h
        ${CMAKE_CURRENT_LIST_DIR}/ListBox.h
        ${CMAKE_CURRENT_LIST_DIR}/Menu.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiEditFwd.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiEdit.h
        ${CMAKE_CURRENT_LIST_DIR}/PtRect.h
        ${CMAKE_CURRENT_LIST_DIR}/Scroll.h
        ${CMAKE_CURRENT_LIST_DIR}/ScrollPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/Slider.h
        ${CMAKE_CURRENT_LIST_DIR}/Spin.h
        ${CMAKE_CURRENT_LIST_DIR}/StaticGraphic.h
        ${CMAKE_CURRENT_LIST_DIR}/StrongTypedef.h
        ${CMAKE_CURRENT_LIST_DIR}/StyleFactory.h
        ${CMAKE_CURRENT_LIST_DIR}/TabWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/TextControl.h
        ${CMAKE_CURRENT_LIST_DIR}/Texture.h
        ${CMAKE_CURRENT_LIST_DIR}/Timer.h
        ${CMAKE_CURRENT_LIST_DIR}/UnicodeCharsets.h
        ${CMAKE_CURRENT_LIST_DIR}/WndEvent.h
        ${CMAKE_CURRENT_LIST_DIR}/Wnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ZList.h
)

=== GG/GG/RichText/CMakeLists.txt ===
# GG is a GUI for OpenGL.
#
# Copyright (C) 2017 Marcel Metz
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA
#
# If you do not wish to comply with the terms of the LGPL please
# contact the author as other terms are available for a fee.
#
# Zach Laine
# whatwasthataddress@gmail.com

target_sources(GiGi
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/BlockControl.h
        ${CMAKE_CURRENT_LIST_DIR}/ImageBlock.h
        ${CMAKE_CURRENT_LIST_DIR}/RichText.h
)

=== debian/changelog ===
freeorion (0.4.10.1-1) unstable; urgency=medium

  * New upstream version 0.4.10.1.

 -- Markus Koschany <apo@debian.org>  Sun, 11 Oct 2020 15:44:38 +0200

=== debian/control ===
Source: freeorion
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-python,
 libalut-dev,
 libboost-all-dev,
 libfreetype6-dev,
 libgl1-mesa-dev,
 libglew-dev,
 libglu1-mesa-dev,
 libjpeg-dev,
 libogg-dev,
 libopenal-dev,
 libpng-dev,
 libsdl2-dev,
 libtiff-dev,
 libvorbis-dev,
 pkg-config,
 python3
Standards-Version: 4.5.0
Homepage: http://www.freeorion.org
Vcs-Git: https://salsa.debian.org/games-team/freeorion.git
Vcs-Browser: https://salsa.debian.org/games-team/freeorion

Package: freeorion
Architecture: linux-any
Depends:
 freeorion-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: turn-based space empire and galactic conquest game
 FreeOrion is a turn-based space empire and galactic conquest (4X) game being
 designed and built by the FreeOrion project. FreeOrion is inspired by the
 tradition of the Master of Orion games, but is not a clone or remake of that
 series or any other game.
 .
 The game is about the construction of a living, breathing universe in a grand
 campaign model. You can develop your own galactic empire and explore new star
 systems with your fleets as one of several unique human or alien species.
 Colonization of new worlds, researching new technology, managing your
 resources and defending your planets against the AI or other human players on
 a galactic scale are your main objectives.

Package: freeorion-data
Architecture: all
Depends:
 fonts-dejavu,
 fonts-roboto-unhinted,
 ${misc:Depends},
 ${python3:Depends}
Suggests:
 freeorion
Description: turn-based space empire and galactic conquest game -- data
 FreeOrion is a turn-based space empire and galactic conquest (4X) game being
 designed and built by the FreeOrion project.
 .
 This package provides architecture-independent data files for FreeOrion,
 hundreds of unique designs for in-game icons, ships and planets, many
 different sounds and an immersive music score.
 .
 Also included are in-game descriptions, translations and game scripts.

=== debian/rules ===
--- 
+++ 
@@ -49,5 +49,6 @@
 	dh_python3 -pfreeorion-data /usr/share/games
 
 get-orig-source:
-	wget https://codeload.github.com/freeorion/freeorion/tar.gz/4428a2ce7bb7cb42f3eae8f7ab0d99a9eed9247f
+	wget https://github.com/freeorion/freeorion/releases/download/v0.4.10.1/FreeOrion_v0.4.10.1_2020-09-25.39cfe10_Source.tar.gz
 
+
